//---------------------------------------------------------------------------
//      .  
//  ,   .   .


#include <vcl.h>
#pragma hdrstop

#include "MainCode.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
        int i;
        StringGrid1->Cells[0][0]="  ";       // false
        StringGrid1->Cells[1][0]="  ";     // true
        StringGrid1->Cells[2][0]="  ";
        StringGrid1->Cells[3][0]="  ";
        StringGrid2->Cells[0][0]="  ";
        StringGrid2->Cells[1][0]=" ";
        StringGrid2->Cells[2][0]=" ";
        Cell=StringGrid2;
}

//   TFregC   
void __fastcall TMainForm::SortFreq(TUnitParam *FreqC, int Num){
        int i;
        bool Run;
        TUnitParam tmp;
        Run=true;
        while(Run){
         Run=false;
         for(i=0;i<Num-1;i++)
          if(FreqC[i].Freq>FreqC[i+1].Freq){
           tmp=FreqC[i];
           FreqC[i]=FreqC[i+1];
           FreqC[i+1]=tmp;
           Run=true;
          }
        }
}

//   TChart  
void __fastcall TMainForm::LACHToChart(TChartSeries *Series,
                TSysParam *S, TUnitParam *U){
        int i;
        float omega,Ku,Mood;
        //   2 ,   
        //  
        omega=FreqMin;Ku=S->Ku;Mood=S->Mood;
        Series->AddXY(omega,20*(log10(Ku)-Mood*log10(omega)),"",clRed);
        //   
        for(i=0;i<S->Units;i++){
         omega=U[i].Freq;
         Series->AddXY(omega,20*(log10(Ku)-Mood*log10(omega)),"",clRed);
         if (U[i].Type) {Mood++;Ku=Ku*omega;}
         else {Mood--;Ku=Ku/omega;}
        }
        // 
        omega=FreqMax;
        Series->AddXY(omega,20*(log10(Ku)-Mood*log10(omega)),"",clRed);
}

//   Chart  
void __fastcall TMainForm::LFCHToChart(TChartSeries *Series,
                TSysParam *S, TUnitParam *U){
        int i,j;
        float Phase,omega,k=180/M_PI;
        //   2 ,   
        //  
        omega=FreqMin;Phase=-90*S->Mood;
        //  
        for(j=0;j<S->Units;j++){
         if (U[j].Type) Phase=Phase-atan(omega/U[j].Freq)*k;
         else Phase=Phase+atan(omega/U[j].Freq)*k;}
        Series->AddXY(omega,Phase,"",clRed);
        //       
        for(i=0;i<S->Units;i++){
         Phase=-90*S->Mood;omega=U[i].Freq;
         //  
         for(j=0;j<S->Units;j++){
          if (U[j].Type) Phase=Phase-atan(omega/U[j].Freq)*k;
          else Phase=Phase+atan(omega/U[j].Freq)*k;}
         Series->AddXY(omega,Phase,"",clRed);
        }
        // 
        omega=FreqMax;Phase=-90*S->Mood;
        //  
        for(j=0;j<S->Units;j++){
         if (U[j].Type) Phase=Phase-atan(omega/U[j].Freq)*k;
         else Phase=Phase+atan(omega/U[j].Freq)*k;}
        Series->AddXY(omega,Phase,"",clRed);
}

//    
void __fastcall TMainForm::SendGraph(){
        int i,j;
        TChartSeries *Series[6];
        TSysParam SS,CU,DS;
        TUnitParam USS[10],UCU[10],UDS[20];
        //    
        if (StringGrid2->Cells[0][1]=="")StringGrid2->Cells[0][1]="1";
        if (StringGrid2->Cells[1][1]=="")StringGrid2->Cells[1][1]="100";
        if (StringGrid2->Cells[2][1]=="")StringGrid2->Cells[2][1]="1";
        SS.Mood=StrToFloat(StringGrid2->Cells[0][1]);
        StringGrid2->Cells[0][1]=IntToStr(SS.Mood);
        SS.Ku=StrToFloat(StringGrid2->Cells[1][1]);
        CU.Ku=StrToFloat(StringGrid2->Cells[2][1]);
        CU.Mood=0;
        DS.Mood=SS.Mood+CU.Mood;
        DS.Ku=SS.Ku*CU.Ku;
        //     
        SS.Units=0;CU.Units=0;DS.Units=0;
        for(j=0;j<2;j++)
         for(i=1;i<6;i++){
          if (StringGrid1->Cells[j][i]!=""){
           USS[SS.Units].Freq=1/StrToFloat(StringGrid1->Cells[j][i]);
           USS[SS.Units].Type=j;
           UDS[DS.Units]=USS[SS.Units];
           SS.Units++;DS.Units++;}
          if (StringGrid1->Cells[j+2][i]!=""){
           UCU[CU.Units].Freq=1/StrToFloat(StringGrid1->Cells[j+2][i]);
           UCU[CU.Units].Type=j;
           UDS[DS.Units]=UCU[CU.Units];
           CU.Units++;DS.Units++;}
         }
        //   
        SortFreq(USS,SS.Units);
        SortFreq(UCU,CU.Units);
        SortFreq(UDS,DS.Units);
        FreqMin=UDS[0].Freq/2;FreqMax=UDS[DS.Units-1].Freq*2;
        //      
        for(i=0;i<6;i++){
         Series[i]=GraphForm->Chart->Series[i];
         Series[i]->Clear();}
        //     
        if(SS.Units!=0)LACHToChart(Series[0],&SS,USS);
        //    
        if(CU.Units!=0)LACHToChart(Series[1],&CU,UCU);
        //     
        if(DS.Units!=0)LACHToChart(Series[3],&DS,UDS);
        //     
        if(DS.Units!=0)LFCHToChart(Series[2],&DS,UDS);
        //    -180  
        Series[4]->AddXY(FreqMin,-180,"",clRed);
        Series[4]->AddXY(FreqMax,-180,"",clRed);
        //0  
        //Series[5]->AddXY(1,90,"",clRed);
        //Series[5]->AddXY(1,-90,"",clRed);


}

void __fastcall TMainForm::Button1Click(TObject *Sender)
{
        TrackFlag=true;
        GraphForm->Show();
        SendGraph();
}
//---------------------------------------------------------------------------

// 

void __fastcall TMainForm::KeyPress(TObject *Sender, char &Key)
{
        if (Key=='.') Key=',';
        if (((Key<'0')|(Key>'9'))&(Key!=',')&(Key!=8)) Key=0;
}
//---------------------------------------------------------------------------

// 

void __fastcall TMainForm::ChartContextPopup(TObject *Sender,
      TPoint &MousePos, bool &Handled)
{
        PopupMenu->Popup(MousePos.x+MainForm->Left,MousePos.y+MainForm->Top);
}
//---------------------------------------------------------------------------

//    

void __fastcall TMainForm::N1Click(TObject *Sender)
{
        //Chart->CopyToClipboardBitmap();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Active(){
         TrackBar1->Enabled=true;
}

void __fastcall TMainForm::Passive(){
         TrackBar1->Enabled=false;
}

void __fastcall TMainForm::TrackBar1Change(TObject *Sender)
{
        static float K;
        static int Col,Row;
        float V;
        if(TrackFlag){
         Col=Cell->Col;
         Row=Cell->Row;
         if (Cell->Cells[Col][Row]=="") Cell->Cells[Col][Row]="0,1";
         K=StrToFloat(Cell->Cells[Col][Row]);
         TrackFlag=false;}
        V=TrackBar1->Position;V=V/10;V=K*exp(V);
        Cell->Cells[Col][Row]=FloatToStr(V);
        SendGraph();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StringGrid2Click(TObject *Sender)
{
        TrackFlag=true;
        TrackBar1->Position=0;
        Cell=StringGrid2;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StringGrid1Click(TObject *Sender)
{
       TrackFlag=true;
       TrackBar1->Position=0;
       Cell=StringGrid1;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button2Click(TObject *Sender)
{
        TrackBar1->Position=0;
        Cell->Cells[Cell->Col][Cell->Row]="";
        SendGraph();
}
//---------------------------------------------------------------------------

