//---------------------------------------------------------------------------

#ifndef MainCodeH
#define MainCodeH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Chart.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>
#include <Series.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include "GraphCode.h"
//---------------------------------------------------------------------------

// 
struct TUnitParam{
        float Freq; // 
        bool  Type; // -   
};

// 
struct TSysParam{
        float Ku;   // 
        int Units;  //  
        int Mood;   //  
};

class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TButton *Button1;
        TStringGrid *StringGrid1;
        TTrackBar *TrackBar1;
        TStaticText *StaticText2;
        TStringGrid *StringGrid2;
        TStaticText *StaticText1;
        TButton *Button2;
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall KeyPress(TObject *Sender, char &Key);
        void __fastcall ChartContextPopup(TObject *Sender,
          TPoint &MousePos, bool &Handled);
        void __fastcall N1Click(TObject *Sender);
        void __fastcall TrackBar1Change(TObject *Sender);
        void __fastcall StringGrid2Click(TObject *Sender);
        void __fastcall StringGrid1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
private:	// User declarations
        TChartSeries *Series[4];
        void __fastcall SendGraph();
        void __fastcall SortFreq(TUnitParam *FreqC,int Num);
        void __fastcall LACHToChart(TChartSeries *Series,
                TSysParam *S,TUnitParam *U);
        void __fastcall TMainForm::LFCHToChart(TChartSeries *Series,
                TSysParam *S, TUnitParam *U);
        bool TrackFlag;
        TStringGrid *Cell;
        float FreqMin,FreqMax;
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
        void __fastcall Active();
        void __fastcall Passive();
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
